# Graph generation

In order to track our progress and where we stand against the competition, we generate lots of data and turn it into graphs as seen [here](cmu_performance.md) for CMU, [here](paragon_performance.md) for Paragon, and [here](fight_scene_performance.md) for the Matinee fight scene.

The steps to generate the graphs are detailed here for transparency.

## Generating the raw performance data

The first step is to run the compression and decompression algorithms in order to extract the raw performance data. This is done by running the [acl_compressor](../tools/acl_compressor) executable.

At the moment, it requires minimal but manual modification to enable the stat dumping as well as to keep only the best permutation we care about tracking. Once this is done, the executable is built.

Next we run it on the input data with the associated python script found [here](../tools/acl_compressor/acl_compressor.py). Typical usage looks like this:

`python acl_compressor.py -acl=<path/to/raw/acl/clips> -stats=<path/to/output/stats> -parallel=4 -csv_summary -csv_bit_rate -csv_error`

This script generates various CSV files. These will be passed to the next step below.

### Matinee fight scene raw performance data

At the moment the raw performance data for the Matinee fight scene is generated by hand through an integration of ACL into Unreal 4. For each release, the integration is updated manually, the clips compressed, and the data extracted by hand.

## Generating the graphs

The generated CSV files in the previous step can be very large and contain lots of things. In order to make sense of it and to make graph generation easier, we use an array of scripts to parse, extract, and format the data into simpler and cleaner CSV files.

These scripts can be found [here](../tools/graph_generation) along with some instructions on how to run them.
